//
//  RootViewController.m
//  MyTris11
//
//  Created by Andrea Busi on 29/09/08.
//  Copyright "The Bubi Devs" 2008. All rights reserved.
//

#import "RootViewController.h"
#import "FlipsideViewController.h"
#import "Constants.h"
#import "MainView.h"


@implementation RootViewController

@synthesize bottoneSetting;
@synthesize bottoneSito;
@synthesize segNGiocatori;
@synthesize segLivello;
@synthesize flipsideViewController;
@synthesize flipsideNavigationBar;
@synthesize mainViewController;
@synthesize rootViewController;


- (void)viewDidLoad {
	
    [super viewDidLoad];
    MainViewController *viewController = [[MainViewController alloc] initWithNibName:@"MainView" bundle:nil];
	self.mainViewController = viewController;
    [viewController release];  
    [self.view insertSubview:mainViewController.view belowSubview:bottoneSetting];
}

- (void)loadFlipsideViewController {
    
    FlipsideViewController *viewController = [[FlipsideViewController alloc] initWithNibName:@"FlipsideView" bundle:nil];
    self.flipsideViewController = viewController;
    [viewController release];
    
    // Set up the navigation bar
    UINavigationBar *aNavigationBar = [[UINavigationBar alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 44.0)];
    aNavigationBar.barStyle = UIBarStyleBlackOpaque;
    self.flipsideNavigationBar = aNavigationBar;
    [aNavigationBar release];
    
    UIBarButtonItem *buttonItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemDone target:self action:@selector(toggleView)];
    UINavigationItem *navigationItem = [[UINavigationItem alloc] initWithTitle:@"Impostazioni"];
    navigationItem.rightBarButtonItem = buttonItem;
    [flipsideNavigationBar pushNavigationItem:navigationItem animated:NO];
    [navigationItem release];
    [buttonItem release];

	//Aggiungo la label "numero giocatori"
	CGFloat yPlacement;
	yPlacement += (kTweenMargin * 2.0) + kSegmentedControlHeight;
	CGRect frame = CGRectMake(	kLeftMargin, yPlacement, viewController.view.bounds.size.width - (kRightMargin * 2.0), kLabelHeight);
	[viewController.view addSubview:[RootViewController labelWithFrame:frame title:@"Numero giocatori:"]];
	
	//Aggiungo il SegmentedControl del numero dei giocatori
	NSArray *gioc = [NSArray arrayWithObjects: @"Un Giocatore", @"Due giocatori",nil];	
	segNGiocatori = [[UISegmentedControl alloc] initWithItems:gioc];
	yPlacement += kTweenMargin + kLabelHeight;
	frame = CGRectMake(	kLeftMargin, yPlacement, viewController.view.bounds.size.width - (kRightMargin * 2.0), kSegmentedControlHeight);
	segNGiocatori.frame = frame;
	segNGiocatori.segmentedControlStyle = UISegmentedControlStyleBordered;
	//Setto la scelta sul valore della partita in corso
	MainView *gameView = [[MainView alloc] init];
	if ([gameView getNumGiocatori] == false)
		segNGiocatori.selectedSegmentIndex = 0;
	else
		segNGiocatori.selectedSegmentIndex = 1;
	//collego l'oggetto segmentedControl all'azione
	[segNGiocatori addTarget:self action:@selector(actionSegGioc:) forControlEvents:UIControlEventValueChanged];
	[viewController.view addSubview:segNGiocatori];
	[segNGiocatori release];
	
	//Aggiungo la label "livello difficoltà"
	yPlacement += (kTweenMargin * 2.0) + kSegmentedControlHeight;
	frame = CGRectMake(	kLeftMargin, yPlacement, viewController.view.bounds.size.width - (kRightMargin * 2.0), kLabelHeight);
	[viewController.view addSubview:[RootViewController labelWithFrame:frame title:@"Livello difficoltà:"]];
	
	//Aggiungo il SegmentedControl del numero dei giocatori
	NSArray *diff = [NSArray arrayWithObjects: @"Facile", @"Medio",@"Difficile",nil];	
	segLivello = [[UISegmentedControl alloc] initWithItems:diff];
	yPlacement += kTweenMargin + kLabelHeight;
	frame = CGRectMake(	kLeftMargin, yPlacement, viewController.view.bounds.size.width - (kRightMargin * 2.0), kSegmentedControlHeight);
	segLivello.frame = frame;
	segLivello.segmentedControlStyle = UISegmentedControlStyleBordered;
	//Setto la scelta sul valore della partita in corso
	switch([gameView getLivello]){
		case 1:{
			segLivello.selectedSegmentIndex = 0;
		};break;
		case 3:{
			segLivello.selectedSegmentIndex = 1;
		};break;
		case 5:{
			segLivello.selectedSegmentIndex = 2;
		};break;
	}
	if (segNGiocatori.selectedSegmentIndex == 1)
		segLivello.enabled = false;
	[gameView release];
	//collego l'oggetto segmentedControl all'azione
	[segLivello addTarget:self action:@selector(actionSegLivello:) forControlEvents:UIControlEventValueChanged];
	[viewController.view addSubview:segLivello];
	[segLivello release];
	 
	//creiamo il bottone x aprire il link al sito
	bottoneSito = [[UIButton buttonWithType:UIButtonTypeRoundedRect] retain];
	bottoneSito.frame = CGRectMake(20.0, 403.0, 280.0, 37.0);
	[bottoneSito setTitle:@"Apri il sito dello sviluppatore" forState:UIControlStateNormal];
	bottoneSito.backgroundColor = [UIColor clearColor];
	[bottoneSito addTarget:self action:@selector(buttonAction:) forControlEvents:UIControlEventTouchUpInside];
	[viewController.view addSubview:bottoneSito];
	[bottoneSito release];
}

//Azione collegata al bottone del sito
-(void)buttonAction:(id)sender{
	//Apriamo la pagina in Safari
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://bubidevs.ispazio.net"]];
}

//Azione collegata al segmented dei giocatori
-(void)actionSegGioc:(id)sender{
	UISegmentedControl *segmentedControl = (UISegmentedControl *)sender;
	NSInteger index = segmentedControl.selectedSegmentIndex;

	if (index == 0){
		[[[MainView alloc] init] setNumGiocatori:false];
		segLivello.enabled = true;
		segLivello.alpha = 1;
	}else{
		[[[MainView alloc] init] setNumGiocatori:true];
		segLivello.enabled = false;
		segLivello.alpha = 0.5;
	}
	
	flagModifiche = true;

}

//Azione collegata al segmented del livello
- (void)actionSegLivello:(id)sender{
	UISegmentedControl *segmentedControl = (UISegmentedControl *)sender;
	NSInteger index = segmentedControl.selectedSegmentIndex;
	
	switch(index){
		case 0: {
			[[[MainView alloc] init] setLivello:1];
		};break;
		case 1: {
			[[[MainView alloc] init] setLivello:3];
		};break;
		case 2: {
			[[[MainView alloc] init] setLivello:5];
		};break;
	}
	flagModifiche =true;
}


+ (UILabel *)labelWithFrame:(CGRect)frame title:(NSString *)title{
    UILabel *label = [[[UILabel alloc] initWithFrame:frame] autorelease];
    
	label.textAlignment = UITextAlignmentLeft;
    label.text = title;
    label.font = [UIFont boldSystemFontOfSize:17.0];
    label.textColor = [UIColor colorWithRed:76.0/255.0 green:86.0/255.0 blue:108.0/255.0 alpha:1.0];
    label.backgroundColor = [UIColor clearColor];
	
    return label;
}


- (IBAction)toggleView {    
    /*
     This method is called when the info or Done button is pressed.
     It flips the displayed view from the main view to the flipside view and vice-versa.
     */
	
    if (flipsideViewController == nil) {
        [self loadFlipsideViewController];
    }
    
    UIView *mainView = mainViewController.view;
    UIView *flipsideView = flipsideViewController.view;
    
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:1];
    [UIView setAnimationTransition:([mainView superview] ? UIViewAnimationTransitionFlipFromRight : UIViewAnimationTransitionFlipFromLeft) forView:self.view cache:YES];
    
    if ([mainView superview] != nil) {
        [flipsideViewController viewWillAppear:YES];
        [mainViewController viewWillDisappear:YES];
        [mainView removeFromSuperview];
        [bottoneSetting removeFromSuperview];
        [self.view addSubview:flipsideView];
        [self.view insertSubview:flipsideNavigationBar aboveSubview:flipsideView];
        [mainViewController viewDidDisappear:YES];
        [flipsideViewController viewDidAppear:YES];
		flagModifiche = false;
    } else {
		//va da impostazioni alla finestra principale
        [mainViewController viewWillAppear:YES];
        [flipsideViewController viewWillDisappear:YES];
        [flipsideView removeFromSuperview];
        [flipsideNavigationBar removeFromSuperview];
        [self.view addSubview:mainView];
        [self.view insertSubview:bottoneSetting aboveSubview:mainViewController.view];
        [flipsideViewController viewDidDisappear:YES];
        [mainViewController viewDidAppear:YES];
		//controlliamo che sia stato modificato qualcosa
		if (flagModifiche == true){
			//Avviamo la nuova partita
			MainView *gameView = [[MainView alloc] init];
			[gameView nuovaPartita];
			[gameView release];
		}
	}
    [UIView commitAnimations];
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [bottoneSetting release];
    [flipsideNavigationBar release];
    [mainViewController release];
    [flipsideViewController release];
    [super dealloc];
}


@end
